<?php
/**
* @version $Id: autoarchive.php 2411 2006-02-16 17:23:32Z tudorilisoi $
* @package Joomla
* @copyright Copyright (C) 2006 TeachMeJoomla
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

$_MAMBOTS->registerFunction( 'onPrepareContent', 'botautoarchive' );

/**
* Code Highlighting Mambot
*
* <b>Usage:</b>
* <code>{autoarchive}...some code...{/autoarchive}</code>
*/
function botautoarchive( $published, &$row, &$params, $page=0 ) {
global $option , $task , $mosConfig_absolute_path , $mosConfig_cachepath , $database;

if (!$published) return;

require_once( $mosConfig_absolute_path . '/includes/Cache/Lite/Function.php' );


// load mambot params info
		$query = "SELECT id FROM #__mambots WHERE element = 'autoarchive' AND folder = 'content'";
		$database->setQuery( $query );
	 	$id 	= $database->loadResult();
	 	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}
	 	
	 	$mambot = new mosMambot( $database );
	  	$mambot->load( $id );
	 	$botparams =& new mosParameters( $mambot->params ); 	


$lifetime=$params->def('lifetime',15);

//only run when viewing items, this prevents multiple executions on blog display and print/email popups
if(  ($option=="com_content")&&( ($task=="view")||($lifetime>0) )  )
{



$cache = new Cache_Lite( 
array("cacheDir" => $mosConfig_cachepath."/", 
  "lifeTime" =>  $lifetime) );



if ($cachedquery = $cache->get("autoarchive-execflag")) {
//echo "<h1>CACHED</h1>";
return true; //simply exit, because interval has not expired yet

}

else
{
 botaaexecute($row,$params, $botparams);
 $cache->save("1","autoarchive-execflag");
 

 
 return true; //exit, because code-based execution is not yet implemented

 
}

}


	// simple performance check to determine whether bot should process further
	if ( strpos( $row->text, 'autoarchive' ) === false ) {
		return true;
	}
	
	// define the regular expression for the bot
	$regex = "#{autoarchive\s(.*?)}#s";

	// check whether mambot has been unpublished
	if ( !$published ) {
		$row->text = preg_replace( $regex, '', $row->text );
		return true;
	}
	
	// perform the replacement


//$row->text = preg_replace_callback( $regex, 'botautoarchive_replacer', $row->text );
//run sql on db

 
	return true;
}
/**
* Replaces the matched tags an image
* @param array An array of matches (see preg_match_all)
* @return string
*/
function botautoarchive_replacer( &$matches ) {
	$html_entities_match = array("#<#", "#>#");
	$html_entities_replace = array("code replaced");

	$text = $matches[1];

	$text = preg_replace($html_entities_match, $html_entities_replace, $text );

	

	return $text;
}

/**
executes action on content items
*/

function botaaexecute(&$itemrow, &$itemparams, &$params)
{
global  $mosConfig_offset;
global $database,$option,$task;
global $mosConfig_mailfrom, $mosConfig_fromname;

	
	 	
//	print_r($params);



$act=$params->def( 'action','' );
$fixnotauth=$params->def( 'fixnotauth',1 );

if ($act)  //take action if set
{
$timenow = date( "Y-m-d H:i:s", time()+$mosConfig_offset*60*60 );




$qlimit=$params->def( 'limit','1' );
$where=Array();
//$where="STATE='1'"; //normal operation
$where[]=" state>=0 ";
$where[]="(publish_down <> '0000-00-00 00:00:00' AND publish_down <= '$timenow'  )";
//sect filter
$sf= 	trim($params->def( 'sectfilter','' ));
if ($sf) $where[]=' sectionid IN ('.$sf.')';
//cat filter
$cf= 	trim($params->def( 'catfilter','' ));
if ($cf) $where[]=' catid IN ('.$cf.') ';

$adminemail=@trim($params->def( 'adminemail',$mosConfig_mailfrom ));

$adminemail=explode(';',$adminemail);

	switch($act)
	{
	case 'archive': 
	$sql="UPDATE #__content   SET state=-1 , modified = " . $database->Quote( date( 'Y-m-d H:i:s' ) ) ;
	if ($fixnotauth) $sql.= ", publish_down='0000-00-00 00:00:00' " ;
	break;
	
	case 'trash': 
	$sql="UPDATE #__content  SET state=-2 , modified = " . $database->Quote( date( 'Y-m-d H:i:s' ) );
	break;
	
	case 'delete': 
	$sql="DELETE FROM #__content   ";
	break;
	
	default:
	//die("Autoexpire action is not set");
	exit();
	break;
	}



//process items and send email before taking action
/*
//debug:determine total number of items
$sql2="SELECT COUNT(id) FROM #__content"
	. ( count( $where ) ? "\n WHERE " . implode( ' AND ', $where ) : "");
	
$database->setQuery($sql2);
$database->query();

$totalrows=$database->LoadResult();

echo "<p>Total $totalrows rows</p>"	;
*/

	
$query=
	"SELECT * from #__content"
	. ( count( $where ) ? "\n WHERE " . implode( ' AND ', $where ) : "")
	
	."\n ORDER BY publish_down ASC"
	. "\n LIMIT $qlimit"
	;
$database->setQuery($query);
$database->query();
$rows=$database->loadObjectList();
if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}
//echo "<pre>$query</pre>";

$mailalert=$params->def( 'mailalert','none' );



$ids=array(); //used to collect ids for update procedure

foreach ($rows as $row)
{
//echo "<h3>$act: ".$row->title." expired on: ".mosFormatDate($row->publish_down,'%d-%m-%Y : %H:%S')."</h3>";


//send mail if configured to do so
$subject="$row->title - Action taken: $act";
$message="An automatic action has been applied to the following item:";
$message.="\r\n\r\n $row->title";
$message.="\r\n\r\n Action taken: $act";
$mode=0; //plain text email

$mailaddy=array();

switch($mailalert)
{
  case 'none':
  break;
  
  case 'both':
  $mailaddy = $mailaddy + $adminemail; //get admin mail
  $sql3="SELECT email from #__users"
  ." WHERE id=$row->created_by"
 // ." AND usertype<>'Super Administrator'" //exclude admins
 ;
  $database->setQuery($sql3);
 $database->query();

if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}
	if (trim($authormail=$database->LoadResult())) $mailaddy[]=$authormail;
	
  break;
  
  case 'author':
  $sql3="SELECT email from #__users WHERE id=$row->created_by";
  $database->setQuery($sql3);
 $database->query();

if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}
	if (trim($authormail=$database->LoadResult())) $mailaddy[]=$authormail;
	
  break;
  
  case 'admins':
  $mailaddy = $mailaddy + $adminemail;
  break;
  
  default:
  break;
}

$mailaddy=array_unique($mailaddy);

//print_r($mailaddy);

//debug

/****
unset($mailaddy);
$mailaddy[]=$adminemail;
****/






if ($mailalert!='none') 
mosMail( $mosConfig_mailfrom, $mosConfig_fromname, $mailaddy, $subject, $message, $mode );

$ids[]=$row->id; //collect id for actual action :P

}

//add ids to where clauses

$idlimit="id IN (" . implode(",",$ids) . ")";


//apply action on items
	$query=$sql
	."\n WHERE ". $idlimit;

	//	."\n ORDER BY publish_down ASC"
//	. "\n LIMIT $qlimit" //this does not seem to work
;

// echo "<pre>$query</pre>";

if(count($ids)) //did we collect something?
{
$database->setQuery($query);
$database->query();

if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}


 /**************
 YOU MAY NOT REMOVE THE  LINE BELOW 
 UNLESS YOU MANUALLY LINK TO http://www.teachmejoomla.net on your website
 ****************/
$itemrow->text.= '<br /><div align="right"><span class="small">Automation by <a href="http://www.teachmejoomla.net">TeachMeJoomla</a></span></div>';
/***************************************************************/



}
//else echo "NOTHING COLLECTED";

//$nrows=$database->getAffectedRows();
//$row->text.="<h3> $nrows affected </h3>";

}


}
?>